<?php
/**
 * Plugin Name: GR Dashboard Notes
 * Plugin URI: https://wordpress.org/plugins/gr-dashboard-notes/
 * Description: This plugin let you create notes on the dashboard for different roles of your choice.
 * Version: 1.0.4
 * Author: Achim T.
 * License: GPL2 or later
 * License URI: https://www.gnu.org/licenses/gpl-2.0.html
 */
  
/* Datenbankeintrag hinzufügen bei Pluginaktivierung */
register_activation_hook(__FILE__,'gr_dashboard_notes_activate'); 
function gr_dashboard_notes_activate() {
add_option('GR_Dashboard_Notes-ID', array());
add_option('GR_Dashboard_Notes-1', '');
add_option('GR_Dashboard_Notes-2', '');
add_option('GR_Dashboard_Notes-3', '');
add_option('GR_Dashboard_Notes-4', '');
add_option('GR_Dashboard_Notes-5', '');
add_option('GR_Dashboard_Notes-Roles-1', array());
add_option('GR_Dashboard_Notes-Roles-2', array());
add_option('GR_Dashboard_Notes-Roles-3', array());
add_option('GR_Dashboard_Notes-Roles-4', array());
add_option('GR_Dashboard_Notes-Roles-5', array());
}
/* Datenbankeintrag löschen bei Löschen des Plugins */
register_uninstall_hook( __FILE__, 'gr_dashboard_notes_remove' );
function gr_dashboard_notes_remove() {
delete_option('GR_Dashboard_Notes-ID');
delete_option('GR_Dashboard_Notes-1');
delete_option('GR_Dashboard_Notes-2');
delete_option('GR_Dashboard_Notes-3');
delete_option('GR_Dashboard_Notes-4');
delete_option('GR_Dashboard_Notes-5');
delete_option('GR_Dashboard_Notes-Roles-1');
delete_option('GR_Dashboard_Notes-Roles-2');
delete_option('GR_Dashboard_Notes-Roles-3');
delete_option('GR_Dashboard_Notes-Roles-4');
delete_option('GR_Dashboard_Notes-Roles-5');
}
/* Überprüfung ob Nutzer Recht hat auf dem Dashboard zu lesen */
add_action( 'current_screen', 'gr_dashboard_notes_allowedcheck');
function gr_dashboard_notes_allowedcheck()
{
	/* Check ob Nutzer Rechte hat auf Dashboard zu lesen */
	if ( current_user_can( 'read' ))
	{
	$gr_dashboard_notes_screencheck = get_current_screen();
		/* Check ob Nutzer auf Dashboard ist */
		if ($gr_dashboard_notes_screencheck -> id == "dashboard")
		{
		 /* Check ob irgendwelche Notes hinterlegt sind */
		 if (array_sum(get_option( 'GR_Dashboard_Notes-ID' )) != 0)
		 {		
		$gr_dashboard_notes_user = wp_get_current_user();
		$gr_dashboard_notes_user_roles = ( array ) $gr_dashboard_notes_user->roles;
		$gr_dashboard_notes_role1 = get_option( 'GR_Dashboard_Notes-Roles-1' );
		$gr_dashboard_notes_role2 = get_option( 'GR_Dashboard_Notes-Roles-2' );
		$gr_dashboard_notes_role3 = get_option( 'GR_Dashboard_Notes-Roles-3' );
		$gr_dashboard_notes_role4 = get_option( 'GR_Dashboard_Notes-Roles-4' );
		$gr_dashboard_notes_role5 = get_option( 'GR_Dashboard_Notes-Roles-5' );	
			/* Check ob Notes für passende Usergroup sind und Wiedergabe */
			/* Check von ID1 */
			if ( in_array($gr_dashboard_notes_user_roles[0], $gr_dashboard_notes_role1 ))
			{
				$gr_dashboard_notes_id = get_option( 'GR_Dashboard_Notes-1' );	
				echo'<div class="notice notice-info is-dismissible">';
				echo wp_kses_post($gr_dashboard_notes_id);
				echo '</div>';
			}
			/* Check von ID2 */
			if ( in_array($gr_dashboard_notes_user_roles[0], $gr_dashboard_notes_role2 ))
			{
				$gr_dashboard_notes_id = get_option( 'GR_Dashboard_Notes-2' );	
				echo'<div class="notice notice-info is-dismissible">';
				echo wp_kses_post($gr_dashboard_notes_id);
				echo '</div>';
			}
			/* Check von ID3 */
			if ( in_array($gr_dashboard_notes_user_roles[0], $gr_dashboard_notes_role3 ))
			{
				$gr_dashboard_notes_id = get_option( 'GR_Dashboard_Notes-3' );	
				echo'<div class="notice notice-info is-dismissible">';
				echo wp_kses_post($gr_dashboard_notes_id); 
				echo '</div>';
			}
			/* Check von ID4 */
			if ( in_array($gr_dashboard_notes_user_roles[0], $gr_dashboard_notes_role4 ))
			{
				$gr_dashboard_notes_id = get_option( 'GR_Dashboard_Notes-4' );	
				echo'<div class="notice notice-info is-dismissible">';
				echo wp_kses_post($gr_dashboard_notes_id);
				echo '</div>';
			}
			/* Check von ID5 */
			if ( in_array($gr_dashboard_notes_user_roles[0], $gr_dashboard_notes_role5 ))
			{
				$gr_dashboard_notes_id = get_option( 'GR_Dashboard_Notes-5' );	
				echo'<div class="notice notice-info is-dismissible">';
				echo wp_kses_post($gr_dashboard_notes_id);
				echo '</div>';
			}
		 }
		}		
	}
}
/* Admin-Menü Anzeige */
include (plugin_dir_path(__FILE__) . 'inc/gr-admin-menu.php');		
?>