<?php
defined( 'ABSPATH' ) or die();
/* Admin-Menü */
add_action( 'admin_menu', 'gr_dashboard_notes_admin_ansicht_einstellungen');
function gr_dashboard_notes_admin_ansicht_einstellungen() 
{ 
	/* Check ob Nutzer Rechte hat Optionen einzustellen */
	if ( current_user_can( 'manage_options' ))
	{ 
		/* Erstellen des Admin-Menüs */
		add_options_page('GR Dashboard Notes', 'GR Dashboard Notes', 'administrator',
		'GR Dashboard Notes', 'gr_dashboard_notes_site');		
		/* ===ADMIN-MENÜ=== */	
		/* Seite im Admin-Menü */
		function gr_dashboard_notes_site() {
					/* ===NOTIZ ERSTELLEN=== */
			/* Wenn Notiz erstellt wurde, wird diese übernommen */
			/* Überprüfen ob Hinzufügen-Formular abgeschickt wurde und Nonce-Check */
			if(isset($_POST['submit']) && wp_verify_nonce( $_POST['gr_dashboard_notes_nonce_field'], 'gr_dashboard_notes_nonce' )){
				/* Überprüfen ob Dashboard Notiz eingegeben wurde sowie Zielgruppe */
				if(!empty($_POST['gr_dashboard_notes-field']) && isset($_POST['gr_dashboard_userrole'])){
					$gr_dashboard_notes_optioncheck = get_option( 'GR_Dashboard_Notes-ID' );
					/* ID-Check für neue Notes. Check ob alle ID's benutzt wurden */
					if ( in_array("1", $gr_dashboard_notes_optioncheck) AND in_array("2", $gr_dashboard_notes_optioncheck) AND in_array("3", $gr_dashboard_notes_optioncheck) AND in_array("4", $gr_dashboard_notes_optioncheck) AND in_array("5", $gr_dashboard_notes_optioncheck) )
					{
					echo '<center><b>';
					esc_html_e( 'Error. You have already 5/5 notes. When you want to post a new one you have to delete an existing one.', 'gr-dashboard-notes' );
					echo '</b></center>';	
					}  
					/* Wenn mindestens eine ID frei ist wird nach dieser gesucht */
					else if (in_array("1",$gr_dashboard_notes_optioncheck) == false)
					{
					$gr_dashboard_notes_setnewid = "1";
					$gr_dashboard_notes_setnewid_note = "GR_Dashboard_Notes-1";
					$gr_dashboard_notes_setnewid_role = "GR_Dashboard_Notes-Roles-1";
					}
					else if (in_array("2",$gr_dashboard_notes_optioncheck) == false)
					{
					$gr_dashboard_notes_setnewid = "2";
					$gr_dashboard_notes_setnewid_note = "GR_Dashboard_Notes-2";
					$gr_dashboard_notes_setnewid_role = "GR_Dashboard_Notes-Roles-2";
					}
					else if (in_array("3",$gr_dashboard_notes_optioncheck) == false)
					{
					$gr_dashboard_notes_setnewid = "3";
					$gr_dashboard_notes_setnewid_note = "GR_Dashboard_Notes-3";
					$gr_dashboard_notes_setnewid_role = "GR_Dashboard_Notes-Roles-3";
					}
					else if (in_array("4",$gr_dashboard_notes_optioncheck) == false)
					{
					$gr_dashboard_notes_setnewid = "4";
					$gr_dashboard_notes_setnewid_note = "GR_Dashboard_Notes-4";
					$gr_dashboard_notes_setnewid_role = "GR_Dashboard_Notes-Roles-4";
					}
					else if (in_array("5",$gr_dashboard_notes_optioncheck) == false)
					{
					$gr_dashboard_notes_setnewid = "5";
					$gr_dashboard_notes_setnewid_note = "GR_Dashboard_Notes-5";
					$gr_dashboard_notes_setnewid_role = "GR_Dashboard_Notes-Roles-5";
					}
						/* Speichere in Datenbank */
						if ($gr_dashboard_notes_setnewid == "1" OR $gr_dashboard_notes_setnewid == "2" OR $gr_dashboard_notes_setnewid == "3" OR $gr_dashboard_notes_setnewid == "4" OR $gr_dashboard_notes_setnewid == "5")
						{
						$gr_dashboard_notes_idarray = $gr_dashboard_notes_optioncheck;
						/* Markiere neue ID als belegt */
						$gr_dashboard_notes_idarray[] = $gr_dashboard_notes_setnewid;
						update_option( 'GR_Dashboard_Notes-ID', $gr_dashboard_notes_idarray);				
						/* Speichere die Notiz an der richtigen Stelle in die Datenbank */
						/* Sanitizing mit wp_kses & sanitizing_text_field */
						$gr_dashboard_notes_setnewtext = wp_kses_post( $_POST['gr_dashboard_notes-field'] );
						$gr_dashboard_notes_setnewroles = array_map( 'sanitize_text_field', wp_unslash( $_POST['gr_dashboard_userrole'] ) );	
						update_option( $gr_dashboard_notes_setnewid_note, $gr_dashboard_notes_setnewtext);
						update_option( $gr_dashboard_notes_setnewid_role, $gr_dashboard_notes_setnewroles);
						echo '<center><b>';
						esc_html_e( 'Note created!', 'gr-dashboard-notes' );
						echo '</b></center>';
						}		
				} 
				else 
				{
				echo '<center><b>';
				esc_html_e( 'Error. No note-text written or target-group selected. Please try it again.', 'gr-dashboard-notes' );
				echo '</b></center>';
				}
			}
			/* ===NOTIZ LÖSCHEN=== */
			/* Wenn Notiz gelöscht werden soll, wird diese gelöscht */
			/* Check ob Löschbutton gedrückt */
			if(isset($_POST['delete1']) || isset($_POST['delete2']) || isset($_POST['delete3']) || isset($_POST['delete4']) || isset($_POST['delete5']))
			{
				/* Check ob Nonce korrekt */
				if (wp_verify_nonce( $_POST['gr_dashboard_notes_nonce_field'], 'gr_dashboard_notes_nonce' ))	
				{
					/* Check welcher Eintrag gelöscht werden soll */
					if(isset($_POST['delete1']) && wp_verify_nonce( $_POST['gr_dashboard_notes_nonce_field'], 'gr_dashboard_notes_nonce' ))
					{
					$gr_dashboard_notes_deletenotice = "1";	
					$gr_dashboard_notes_setoldid_note = "GR_Dashboard_Notes-1";
					$gr_dashboard_notes_setoldid_role = "GR_Dashboard_Notes-Roles-1";
					}
					else if(isset($_POST['delete2']) && wp_verify_nonce( $_POST['gr_dashboard_notes_nonce_field'], 'gr_dashboard_notes_nonce' ))
					{
					$gr_dashboard_notes_deletenotice = "2";			
					$gr_dashboard_notes_setoldid_note = "GR_Dashboard_Notes-2";
					$gr_dashboard_notes_setoldid_role = "GR_Dashboard_Notes-Roles-2";
					}
					else if(isset($_POST['delete3']) && wp_verify_nonce( $_POST['gr_dashboard_notes_nonce_field'], 'gr_dashboard_notes_nonce' ))
					{
					$gr_dashboard_notes_deletenotice = "3";			
					$gr_dashboard_notes_setoldid_note = "GR_Dashboard_Notes-3";
					$gr_dashboard_notes_setoldid_role = "GR_Dashboard_Notes-Roles-3";					
					}
					else if(isset($_POST['delete4']) && wp_verify_nonce( $_POST['gr_dashboard_notes_nonce_field'], 'gr_dashboard_notes_nonce' ))
					{
					$gr_dashboard_notes_deletenotice = "4";
					$gr_dashboard_notes_setoldid_note = "GR_Dashboard_Notes-4";
					$gr_dashboard_notes_setoldid_role = "GR_Dashboard_Notes-Roles-4";					
					}
					else if(isset($_POST['delete5']) && wp_verify_nonce( $_POST['gr_dashboard_notes_nonce_field'], 'gr_dashboard_notes_nonce' ))
					{
					$gr_dashboard_notes_deletenotice = "5";			
					$gr_dashboard_notes_setoldid_note = "GR_Dashboard_Notes-5";
					$gr_dashboard_notes_setoldid_role = "GR_Dashboard_Notes-Roles-5";					
					}
						$gr_dashboard_notes_optioncheck = get_option( 'GR_Dashboard_Notes-ID' );
						/* Suche im Array nach Wert */
						if (in_array($gr_dashboard_notes_deletenotice,$gr_dashboard_notes_optioncheck))
						{
						/* Suche nach dazugehörigen Schlüssel */
						$gr_dashboard_notes_deletenoticekey=array_search($gr_dashboard_notes_deletenotice,$gr_dashboard_notes_optioncheck);
						/* Löschen des Array Eintrags */
						unset($gr_dashboard_notes_optioncheck[$gr_dashboard_notes_deletenoticekey]);
						/* Sortiere die Keys neu */
						$gr_dashboard_notes_optioncheck=array_values($gr_dashboard_notes_optioncheck);
						/* Speichere das neue Array */
						update_option( 'GR_Dashboard_Notes-ID', $gr_dashboard_notes_optioncheck);
						/* Entferne altem Text und Roles */
						update_option( $gr_dashboard_notes_setoldid_note, '');
						update_option( $gr_dashboard_notes_setoldid_role, '');
						echo '<center><b>';
						esc_html_e( 'Note deleted!', 'gr-dashboard-notes' );
						echo '</b></center>';
						}
				}
			}
		/* Text der Setup-Seite */
		/* CSS der Adminseite */
		?>
		<style type="text/css">
		table.grdashboardnotes td {font-size: 14px;}
		</style>
		<h1>GR Dashboard Notes</h1>
		<h2>
		<?php esc_html_e( 'Manual', 'gr-dashboard-notes' );
		echo '</h2><b>';
		esc_html_e( 'Add a note:', 'gr-dashboard-notes' );
		echo '</b><br>';
		esc_html_e( '1. Insert your desired text into the text-field below.', 'gr-dashboard-notes' );
		echo '<br>';
		esc_html_e( '2. Select the usergroups who should see the notice.', 'gr-dashboard-notes' );
		echo '<br>';
		esc_html_e( '3. Press the save-button.', 'gr-dashboard-notes' );
		echo '<br>';
		esc_html_e( '4. The new note will be shown at the dashboard.', 'gr-dashboard-notes' );
		echo '<br><br><b>';
		esc_html_e( 'Delete a note:', 'gr-dashboard-notes' );
		echo '</b><br>';
		esc_html_e( 'Click on the delete button from the note who should be deleted.', 'gr-dashboard-notes' );
		echo '<br><br>';
			/* Zählen der Note-Einträge und Ausgabe der Menge */
			$gr_dashboard_notes_optioncheck = get_option( 'GR_Dashboard_Notes-ID' );
			$gr_dashboard_notes_optionscheck_count = count($gr_dashboard_notes_optioncheck);
			echo '<b>';
			echo $gr_dashboard_notes_optionscheck_count;
			echo '/5 ';
			esc_html_e( 'notes published', 'gr-dashboard-notes' );
			echo '</b><br>';
			/* Bisherige Speicherungen abrufen */
			if (array_sum(get_option( 'GR_Dashboard_Notes-ID' )) == 0)	
			{ 
			echo '<center><b>';
			esc_html_e( 'No Dashboard notes published.', 'gr-dashboard-notes' );
			echo '</b></center>';
			}
		    else { 		
			echo '
			<table border="2" width="80%" class="grdashboardnotes">
			<tr>
			<td width="10%">';
			esc_html_e ( 'ID', 'gr-dashboard-notes' );
			echo '</td>
			<td width="70%">';
			esc_html_e ( 'Text', 'gr-dashboard-notes' );
			echo '</td>
			<td>';
			esc_html_e ( 'Usergroups', 'gr-dashboard-notes' );
			echo'</td>
			<td>';
			esc_html_e ( 'Delete', 'gr-dashboard-notes' );
			echo'</td>
			</tr>
			';
				/* Abruf der vorhandenen ID's mit den dazugehörigen Text und Roles */
				$gr_dashboard_notes_optioncheck2 = get_option( 'GR_Dashboard_Notes-ID' );
				/* ID 1 Abruf */
				if (in_array("1", $gr_dashboard_notes_optioncheck2))
				{
				$gr_dashboard_notes_search_id = '1';
				$gr_dashboard_notes_search_notes = get_option( 'GR_Dashboard_Notes-1' );
				$gr_dashboard_notes_search_roles = get_option( 'GR_Dashboard_Notes-Roles-1' );
				echo '<tr><td height="150">';
				echo esc_html ($gr_dashboard_notes_search_id);
				echo '</td><td>';
				echo esc_html ($gr_dashboard_notes_search_notes);
				echo '</td><td>';
				foreach ($gr_dashboard_notes_search_roles as $gr_dashboard_notes_search_roles_ordered) {
								echo esc_html ($gr_dashboard_notes_search_roles_ordered);
								echo '<br>';
				}
				echo '</td><td><form action="" method="post" id="gr_dashboard_notes">';
				wp_nonce_field( 'gr_dashboard_notes_nonce', 'gr_dashboard_notes_nonce_field' );	
				echo '<span class="submit" style="border: 0;"><input type="submit" name="delete1" value="';
				esc_html_e( 'Delete', 'gr-dashboard-notes' );
				echo '" /></span></form></tr>';
				}				
				/* ID 2 Abruf */				
				if (in_array("2", $gr_dashboard_notes_optioncheck2))
				{
				$gr_dashboard_notes_search_id = '2';
				$gr_dashboard_notes_search_notes = get_option( 'GR_Dashboard_Notes-2' );
				$gr_dashboard_notes_search_roles = get_option( 'GR_Dashboard_Notes-Roles-2' );
				echo '<tr><td height="150">';
				echo esc_html ($gr_dashboard_notes_search_id);
				echo '</td><td>';
				echo esc_html ($gr_dashboard_notes_search_notes);
				echo '</td><td>';
				foreach ($gr_dashboard_notes_search_roles as $gr_dashboard_notes_search_roles_ordered) {
								echo esc_html ($gr_dashboard_notes_search_roles_ordered);
								echo '<br>';
				}
				echo '</td><td><form action="" method="post" id="gr_dashboard_notes">';
				wp_nonce_field( 'gr_dashboard_notes_nonce', 'gr_dashboard_notes_nonce_field' );	
				echo '<span class="submit" style="border: 0;"><input type="submit" name="delete2" value="';
				esc_html_e( 'Delete', 'gr-dashboard-notes' );
				echo '" /></span></form></tr>';
				}
				/* ID 3 Abruf */				
				if (in_array("3", $gr_dashboard_notes_optioncheck2))
				{
				$gr_dashboard_notes_search_id = '3';
				$gr_dashboard_notes_search_notes = get_option( 'GR_Dashboard_Notes-3' );
				$gr_dashboard_notes_search_roles = get_option( 'GR_Dashboard_Notes-Roles-3' );
				echo '<tr><td height="150">';
				echo esc_html ($gr_dashboard_notes_search_id);
				echo '</td><td>';
				echo esc_html ($gr_dashboard_notes_search_notes);
				echo '</td><td>';
				foreach ($gr_dashboard_notes_search_roles as $gr_dashboard_notes_search_roles_ordered) {
								echo esc_html ($gr_dashboard_notes_search_roles_ordered);
								echo '<br>';
				}
				echo '</td><td><form action="" method="post" id="gr_dashboard_notes">';
				wp_nonce_field( 'gr_dashboard_notes_nonce', 'gr_dashboard_notes_nonce_field' );	
				echo '<span class="submit" style="border: 0;"><input type="submit" name="delete3" value="';
				esc_html_e( 'Delete', 'gr-dashboard-notes' );
				echo '" /></span></form></tr>';
				}
				/* ID 4 Abruf */				
				if (in_array("4", $gr_dashboard_notes_optioncheck2))
				{
				$gr_dashboard_notes_search_id = '4';
				$gr_dashboard_notes_search_notes = get_option( 'GR_Dashboard_Notes-4' );
				$gr_dashboard_notes_search_roles = get_option( 'GR_Dashboard_Notes-Roles-4' );
				echo '<tr><td height="150">';
				echo esc_html ($gr_dashboard_notes_search_id);
				echo '</td><td>';
				echo esc_html ($gr_dashboard_notes_search_notes);
				echo '</td><td>';
				foreach ($gr_dashboard_notes_search_roles as $gr_dashboard_notes_search_roles_ordered) {
								echo esc_html ($gr_dashboard_notes_search_roles_ordered);
								echo '<br>';
				}
				echo '</td><td><form action="" method="post" id="gr_dashboard_notes">';
				wp_nonce_field( 'gr_dashboard_notes_nonce', 'gr_dashboard_notes_nonce_field' );	
				echo '<span class="submit" style="border: 0;"><input type="submit" name="delete4" value="';
				esc_html_e( 'Delete', 'gr-dashboard-notes' );
				echo '" /></span></form></tr>';
				}
				/* ID 5 Abruf */				
				if (in_array("5", $gr_dashboard_notes_optioncheck2))
				{
				$gr_dashboard_notes_search_id = '5';
				$gr_dashboard_notes_search_notes = get_option( 'GR_Dashboard_Notes-5' );
				$gr_dashboard_notes_search_roles = get_option( 'GR_Dashboard_Notes-Roles-5' );
				echo '<tr><td height="150">';
				echo esc_html ($gr_dashboard_notes_search_id);
				echo '</td><td>';
				echo esc_html ($gr_dashboard_notes_search_notes);
				echo '</td><td>';
				foreach ($gr_dashboard_notes_search_roles as $gr_dashboard_notes_search_roles_ordered) {
								echo esc_html ($gr_dashboard_notes_search_roles_ordered);
								echo '<br>';
				}
				echo '</td><td><form action="" method="post" id="gr_dashboard_notes">';
				wp_nonce_field( 'gr_dashboard_notes_nonce', 'gr_dashboard_notes_nonce_field' );	
				echo '<span class="submit" style="border: 0;"><input type="submit" name="delete5" value="';
				esc_html_e( 'Delete', 'gr-dashboard-notes' );
				echo '" /></span></form></tr>';
				}
				echo '</table><br><br>';
			}
		/* ===ERSTELLEN MENÜ=== */
		/* Einstellmenü */
		?>
		<br><h2>
		<?php esc_html_e( 'Add a new note:', 'gr-dashboard-notes' );?>
		</h2><table border="2" width="80%" class="grdashboardnotes">
		<tr>
		<td width="70%"><?php esc_html_e ( 'Text', 'gr-dashboard-notes' );?></td>
		<td><?php esc_html_e ( 'Usergroups', 'gr-dashboard-notes' );?></td>
		</tr>
		<tr>

		<td><form action="" method="post" id="gr_dashboard_notes">
		<textarea rows="5" cols="140" name="gr_dashboard_notes-field"></textarea></td>
		<td>
		<fieldset><ul>
			<?php foreach (get_editable_roles() as $gr_dashboard_notes_userroles_names => $gr_dashboard_notes_userroles_infos) {
			/* Nonce-Erstellung */
			wp_nonce_field( 'gr_dashboard_notes_nonce', 'gr_dashboard_notes_nonce_field' );	
			/* Userrole Abfrage */	
			echo "<li><label><input type=\"checkbox\" name=\"gr_dashboard_userrole[]\" value=\"$gr_dashboard_notes_userroles_names\">$gr_dashboard_notes_userroles_names</label></li>";
			} ?>
		</ul></fieldset>
		<?php /* Absendebutton für neue Dashboard Notiz */
		echo '<span class="submit" style="border: 0;"><input type="submit" name="submit" value="';
		esc_html_e( 'Save', 'gr-dashboard-notes' );
		echo '" /></span></form>';?> 	  
		</td>
		</tr>
		</table>
		<?php			
		}

	} 
}
?>